 rem           GoB! Fight for the Desert  v6a
 rem ----------------------------------------------------------
 rem    LCC 2700 Spring 06
 rem                        Patrick Jahn
 rem                        Greg Kinsey
 rem                        John Swisshelm
 rem ----------------------------------------------------------
 
 rem Variables listing
 rem -----------------
 rem a -> punch
 rem b -> punch2
 rem c -> used for clearscreen
 rem d -> nopunch
 rem e -> nopunch2
 rem f -> used for flicker
 rem g -> p0death
 rem h -> p1death
 rem i -> buzz variable
 rem j ->
 rem k -> sectimer
 rem l -> frametimer
 rem m -> invincible0
 rem n -> invincible1
 rem o -> p0score
 rem p -> p1score
 rem q ->
 rem r -> pfadd
 rem s -> pfadd2
 rem t ->
 rem u ->
 rem v -> used for player1 x
 rem w -> used for player1 y
 rem x -> used for player0 x
 rem y -> used for player0 y
 rem z -> used for buzz 1

init
 rem --- frametimer counts frames
 dim frametimer = l

 rem --- sectimer counts seconds based on 60 frames per second
 dim sectimer = k

 rem --- death counter for explosion and reset uses g,h
 dim p0death = g
 dim p1death = h

 rem --- punch counters use vars a, b
 dim punch = a
 dim punch2 = b
 
 rem --- nopunch counter use vars d, e keeps player from continuously holding punch
 dim nopunch = d
 dim nopunch2 = e

 rem --- invincibility counter for each player for after death
 dim invincible0 = m
 dim invincible1 = n

 rem --- score tracking
 dim p0score = o
 dim p1score = p

startgame

 score = 0
 p0score = 0
 p1score = 0

 rem --- player starting positions
 x = 70 : y = 70 
 v = 110 : w = 70

 rem ---------- PLAYFIELD SETUP

 rem --- clear screen
 c = 0 
clearscreen
 pfhline 0 c 31 off
 if c <= 11 then c = c + 1 : goto clearscreen

 rem--- playfield colors tan & brown, score is white
 COLUPF = 36
 COLUBK = 44
 scorecolor = 14

 rem --- pfadd stores rands to add to the playfield uses q, r
 dim pfadd = r
 pfadd = 10
 dim pfadd2 = q

 pfvline 0 0 11
 pfvline 1 0 11
 pfvline 30 0 11
 pfvline 31 0 11
 pfpixel 2 0 on:pfpixel 29 0 on:pfpixel 2 1 on:pfpixel 3 1 on
 pfpixel 28 1 on:pfpixel 29 1 on:pfpixel 2 2 on:pfpixel 28 2 on
 pfpixel 29 2 on:pfpixel 29 3 on:pfpixel 2 4 on:pfpixel 2 5 on
 pfpixel 3 5 on:pfpixel 2 6 on:pfpixel 29 6 on:pfpixel 28 7 on
 pfpixel 29 7 on:pfpixel 2 8 on:pfpixel 29 8 on:pfpixel 2 9 on
 pfpixel 3 9 on:pfpixel 2 10 on:pfpixel 3 10 on:pfpixel 29 10 on

 rem --- vertical bar on sides
 PF0=128

 sectimer = 0
 frametimer = 0

mainloop

 rem --- fix bug where players get stuck on each other after death
 if x = v && y = w then x = x + 1 : w = w + 1

 rem --- TIMERS
 frametimer = frametimer + 1
 if frametimer >= 60 then frametimer = 0 : sectimer = sectimer + 1

 rem --- INVINCIBILITY DECREMENT
 if invincible0 > 0 then invincible0 = invincible0 - 1
 if invincible1 > 0 then invincible1 = invincible1 - 1

 rem --- SCENERY CHANGE
 rem -- start out with 36 and 44
 if sectimer = 30 then COLUPF = 32 : COLUBK = 38
 if sectimer = 60 then COLUPF = 32 : COLUBK = 242
 if sectimer = 90 then COLUPF = 160 : COLUBK = 2
 if sectimer = 120 then COLUPF = 36 : COLUBK = 44 : sectimer = 0 : goto winsound0

 rem --- required to stop artifacts
 if playfieldpos<>7 then skip

 rem --------------------- PLAYFIELD RANDOMIZATION
 rem -- random seed
 rand = rand

 rem -- first clear out old pixels
 pfhline 4 11 27 off

 rem -- then generate new pixels
 pfadd = rand
 if pfadd > 92 then goto skip
reduce_pfadd
 if pfadd >23 then pfadd = pfadd - 23 : goto reduce_pfadd
 pfadd = pfadd + 3 
 pfpixel pfadd 11 on
 pfadd2 = pfadd + 1
 pfpixel pfadd2 11 on
skip

 pfscroll down

 rem ---- INVINCIBILITY CHECK and PLAYER COLOR
 if invincible0 > 0 then COLUP0 = 12 else COLUP0 = 68
 if invincible1 > 0 then COLUP1 = 12 else COLUP1 = 132

 rem ------------------------------------------------ PLAYER0

 rem ----------------- death sprites
 if p0death > 10 then goto death0a
 if p0death > 5 then goto death0b
 if p0death > 0 then goto death0c
 
 rem ----------------- punch sprites
 rem --- if 0 < punch <= 5 then left punch
 rem --- if 5 < punch <= 10 then right punch
 if punch > 0  && punch <= 5 then goto leftpunch
 if punch > 5 then goto rightpunch
 rem --- if it makes it here, punch = 0
 rem --- everytime you punch, it will set nopunch to five. The loop will not let you punch until it is back to zero
 if nopunch > 0 then nopunch = nopunch - 1
 if nopunch > 0 then goto normal
 if joy0left && joy0fire then punch = 0 : goto leftpunch
 if joy0right && joy0fire then punch = 6 : goto rightpunch
 rem if joy0fire then goto rightpunch

normal
 rem ----------------- normal sprites
 if joy0left && f = 2 then goto leftflicker
 if joy0right && f = 2 then goto rightflicker

 if f = 2 then goto flicker

 if joy0left then goto left
 if joy0right then goto right

 player0:
 %00011000
 %00011000
 %00011000
 %00111100
 %01011010
 %01100110
 %00100100
 %01100110
 %01011010
 %01011010
 %00100100
 %00011000
 %00011000
 %00011000
 %00011000
end
 goto player1

flicker
 player0: 
 %00000000
 %00000000
 %00000000
 %00111100
 %01011010
 %01100110
 %00100100
 %01100110
 %01011010
 %01011010
 %00100100
 %00011000
 %00000000
 %00000000
 %00000000
end
 goto player1

left
 player0:
 %00011000
 %00011000
 %00011000
 %00111100
 %01011010
 %01100110
 %00100100
 %01101100
 %01110010
 %01110010
 %00100100
 %00011000
 %00011000
 %00011000
 %00011000
end
 goto player1

leftflicker
 player0:
 %00000000
 %00000000
 %00000000
 %00111100
 %01011010
 %01100110
 %00100100
 %01101100
 %01110010
 %01110010
 %00100100
 %00011000
 %00000000
 %00000000
 %00000000
end
 goto player1

right
 player0:
 %00011000
 %00011000
 %00011000
 %00111100
 %01011010
 %01100110
 %00100100
 %00110110
 %01001110
 %01001110
 %00100100
 %00011000
 %00011000
 %00011000
 %00011000
end
 goto player1

rightflicker
 player0:
 %00000000
 %00000000
 %00000000
 %00111100
 %01011010
 %01100110
 %00100100
 %00110110
 %01001110
 %01001110
 %00100100
 %00011000
 %00000000
 %00000000
 %00000000
end
 goto player1

leftpunch
 if f = 2 then goto leftpunchflicker
 player0:
 %00011000
 %00011000
 %00011000
 %00111100
 %01011010
 %01100110
 %00100100
 %11100110
 %00011010
 %00011010
 %00100100
 %00011000
 %00011000
 %00011000
 %00011000
end
 if punch = 5 then punch = 0 : nopunch = 15 else punch = punch + 1
 goto player1

leftpunchflicker
 player0:
 %00000000
 %00000000
 %00000000
 %00111100
 %01011010
 %01100110
 %00100100
 %11100110
 %00011010
 %00011010
 %00100100
 %00011000
 %00000000
 %00000000
 %00000000
end
 if punch = 5 then punch = 0 : nopunch = 15 else punch = punch + 1
 goto player1

rightpunch
 if f = 2 then goto rightpunchflicker
 player0:
 %00011000
 %00011000
 %00011000
 %00111100
 %01011010
 %01100110
 %00100100
 %01100111
 %01011000
 %01011000
 %00100100
 %00011000
 %00011000
 %00011000
 %00011000
end
 if punch = 10 then punch = 0 : nopunch = 15 else punch = punch + 1
 goto player1

rightpunchflicker
 player0:
 %00000000
 %00000000
 %00000000
 %00111100
 %01011010
 %01100110
 %00100100
 %01100111
 %01011000
 %01011000
 %00100100
 %00011000
 %00000000
 %00000000
 %00000000
end
 if punch = 10 then punch = 0 : nopunch = 15 else punch = punch + 1
 goto player1

death0a
 player0:
 %00001100
 %00001100
 %01001101
 %00011000
 %01011010
 %01100110
 %00100100
 %01100110
 %11000100
 %11000010
 %00100100
 %00110000
 %00110000
 %00110000
 %00000000
end
 p0death = p0death - 1
 goto buzz

death0b
 player0:
 %00010000
 %01000010
 %00011000
 %00100100
 %01000010
 %10011001
 %01000010
 %00100100
 %00011000
 %00000000
 %01000010
 %00000000
 %00000000
 %00000000
 %00000000
end
 p0death = p0death - 1
 goto player1

death0c
 player0:
 %00000000
 %00000000
 %00000000
 %00010000
 %00101000
 %00010000
 %00000000
 %00000000
 %00000000
 %00000000
 %00000000
 %00000000
 %00000000
 %00000000
 %00000000
end
 p0death = p0death - 1
 rem --- PLAYER0 DEATH ------------
 rem reset player0, enable invincibility, increase player1's score
 if p0death = 0 then x = 70 : y = 70 : invincible0 = 45 : p1score = p1score + 1 : score = score + 1
 goto player1




player1
 rem ------------------------------------------- PLAYER 1

 rem ----------------- death sprites
 if p1death > 10 then goto death1a
 if p1death > 5 then goto death1b
 if p1death > 0 then goto death1c

 rem ----------------- punch sprites
 rem --- if 0 < punch2 <= 5 then left punch2
 rem --- if 5 < punch2 <= 10 then right punch2
 if punch2 > 0  && punch2 <= 5 then goto leftpunch2
 if punch2 > 5 then goto rightpunch2
 rem --- if it makes it here, punch2 = 0
 rem --- everytime you punch, it will set nopunch2 to five. The loop will not let you punch until it is back to zero
 if nopunch2 > 0 then nopunch2 = nopunch2 - 1
 if nopunch2 > 0 then goto normal2
 if joy1left && joy1fire then punch2 = 0 : goto leftpunch2
 if joy1right && joy1fire then punch2 = 6 : goto rightpunch2
 rem if joy1fire then goto rightpunch2

normal2
 rem ----------------- normal sprites
 if joy1left && f = 2 then goto leftflicker2
 if joy1right && f = 2 then goto rightflicker2

 if f = 2 then goto flicker2

 if joy1left then goto left2
 if joy1right then goto right2

 player1:
 %00011000
 %00011000
 %00011000
 %00111100
 %01011010
 %01100110
 %00100100
 %01100110
 %01011010
 %01011010
 %00100100
 %00011000
 %00011000
 %00011000
 %00011000
end
 f = f + 1
 goto paint

flicker2
 player1: 
 %00000000
 %00000000
 %00000000
 %00111100
 %01011010
 %01100110
 %00100100
 %01100110
 %01011010
 %01011010
 %00100100
 %00011000
 %00000000
 %00000000
 %00000000
end
 f = 0
 goto paint

left2
 player1:
 %00011000
 %00011000
 %00011000
 %00111100
 %01011010
 %01100110
 %00100100
 %01101100
 %01110010
 %01110010
 %00100100
 %00011000
 %00011000
 %00011000
 %00011000
end
 f = f + 1
 goto paint

leftflicker2
 player1:
 %00000000
 %00000000
 %00000000
 %00111100
 %01011010
 %01100110
 %00100100
 %01101100
 %01110010
 %01110010
 %00100100
 %00011000
 %00000000
 %00000000
 %00000000
end
 f = 0
 goto paint

right2
 player1:
 %00011000
 %00011000
 %00011000
 %00111100
 %01011010
 %01100110
 %00100100
 %00110110
 %01001110
 %01001110
 %00100100
 %00011000
 %00011000
 %00011000
 %00011000
end
 f = f + 1
 goto paint

rightflicker2
 player1:
 %00000000
 %00000000
 %00000000
 %00111100
 %01011010
 %01100110
 %00100100
 %00110110
 %01001110
 %01001110
 %00100100
 %00011000
 %00000000
 %00000000
 %00000000
end
 f = 0
 goto paint

leftpunch2
 if f = 2 then goto leftpunchflicker2
 player1:
 %00011000
 %00011000
 %00011000
 %00111100
 %01011010
 %01100110
 %00100100
 %11100110
 %00011010
 %00011010
 %00100100
 %00011000
 %00011000
 %00011000
 %00011000
end
 f = f + 1
 if punch2 = 5 then punch2 = 0 : nopunch2 = 15 else punch2 = punch2 + 1
 goto paint

leftpunchflicker2
 player1:
 %00000000
 %00000000
 %00000000
 %00111100
 %01011010
 %01100110
 %00100100
 %11100110
 %00011010
 %00011010
 %00100100
 %00011000
 %00000000
 %00000000
 %00000000
end
 f = 0
 if punch2 = 5 then punch2 = 0 : nopunch2 = 15 else punch2 = punch2 + 1
 goto paint

rightpunch2
 if f = 2 then goto rightpunchflicker2
 player1:
 %00011000
 %00011000
 %00011000
 %00111100
 %01011010
 %01100110
 %00100100
 %01100111
 %01011000
 %01011000
 %00100100
 %00011000
 %00011000
 %00011000
 %00011000
end
 f = f + 1
 if punch2 = 10 then punch2 = 0 : nopunch2 = 15 else punch2 = punch2 + 1
 goto paint

rightpunchflicker2
 player1:
 %00000000
 %00000000
 %00000000
 %00111100
 %01011010
 %01100110
 %00100100
 %01100111
 %01011000
 %01011000
 %00100100
 %00011000
 %00000000
 %00000000
 %00000000
end
 f = 0
 if punch2 = 10 then punch2 = 0 : nopunch2 = 15 else punch2 = punch2 + 1
 goto paint

death1a
 player1:
 %00001100
 %00001100
 %01001101
 %00011000
 %01011010
 %01100110
 %00100100
 %01100110
 %11000100
 %11000010
 %00100100
 %00110000
 %00110000
 %00110000
 %00000000
end
 p1death = p1death - 1
 goto buzz1

death1b
 player1:
 %00010000
 %01000010
 %00011000
 %00100100
 %01000010
 %10011001
 %01000010
 %00100100
 %00011000
 %00000000
 %01000010
 %00000000
 %00000000
 %00000000
 %00000000
end
 p1death = p1death - 1
 goto paint

death1c
 player1:
 %00000000
 %00000000
 %00000000
 %00010000
 %00101000
 %00010000
 %00000000
 %00000000
 %00000000
 %00000000
 %00000000
 %00000000
 %00000000
 %00000000
 %00000000
end
 p1death = p1death - 1
 rem --- PLAYER1 DEATH ------------
 rem reset player1, enable invincibility, increase player0's score
 if p1death = 0 then v = 110 : w = 70 : invincible1 = 45 : p0score = p0score + 1 : score = score + 10000
 goto paint


 rem ------------------------ PAINT
paint
 goto puttsound
backtopaint
 rem --------- player 0 x,y = x,y  player 1 x,y = v,w
 player0x = x : player0y = y
 player1x = v : player1y = w
 drawscreen

 if switchreset then goto startgame

 if collision(player0,playfield) && invincible0 = 0 then goto fieldcollision0
 if collision(player1,playfield) && invincible1 = 0 then goto fieldcollision1
 if collision(player0,player1) then goto playercollision


freemovep0
 if joy0left then x = x - 1
 if joy0right then x = x + 1
 if joy0up then y = y - 1
 if joy0down then y = y + 1

 if p1death > 0 then goto bounds

freemovep1
 if joy1left then v = v - 1
 if joy1right then v = v + 1
 if joy1up then w = w - 1
 if joy1down then w = w + 1

 goto bounds

playercollision
 rem --- player0 is left of player1
 if x < v then x = x - 1 : v = v + 1
 rem ------- player0 punches right
 if x < v && punch > 5 then v = v + 15 : goto punchsound
 rem ------- player1 punches left
 if x < v && punch2 > 0 then x = x - 15 : goto punchsound

 rem --- player0 is right of player1
 if x > v then x = x + 1 : v = v - 1
 rem ------- player0 punches left
 if x > v && punch > 0 then v = v - 15 : goto punchsound
 rem ------- player1 punches right
 if x > v && punch2 > 5 then x = x + 15 : goto punchsound

 rem --- player0 is top of player1
 if y < w then y = y - 1 : w = w + 1

 rem --- player0 is bottom of player1
 if y > w then y = y + 1 : w = w - 1

 goto bounds

fieldcollision0
 rem --- player0 hits wall and dies!
 if p0death = 0 then p0death = 15
 goto freemovep1

fieldcollision1
 rem --- player1 hits wall and dies!
 if p1death = 0 then p1death = 15
 goto freemovep0

bounds
 rem --- keep the players within bounds!
 rem --- top bound
 if y < 16 then y = 16
 if w < 16 then w = 16
 rem --- bottom bound
 if y > 88 then y = 88
 if w > 88 then w = 88
 rem --- left and right bounds might not be needed!
 rem --- left bound
 if x < 30 then x = 30
 if v < 30 then v = 30
 rem --- right bound
 if x > 152 then x = 152
 if v > 152 then v = 152

 goto mainloop

 rem ------------------------------------------ GAME OVER
finishgame
 rem --- clear screen
 c = 0 
clearscreen2
 pfhline 0 c 31 off
 if c <= 11 then c = c + 1 : goto clearscreen2

 pfpixel 11 4 on:pfpixel 17 4 on:pfpixel 19 4 on:pfpixel 21 4 on
 pfpixel 22 4 on:pfpixel 24 4 on:pfpixel 12 5 on:pfpixel 14 5 on
 pfpixel 16 5 on:pfpixel 19 5 on:pfpixel 21 5 on:pfpixel 23 5 on
 pfpixel 24 5 on:pfpixel 13 6 on:pfpixel 15 6 on:pfpixel 19 6 on
 pfpixel 21 6 on:pfpixel 24 6 on

 if p0score > p1score then goto p0wins
 if p0score < p1score then goto p1wins
 goto tie

p0wins
 COLUP0 = 68
 COLUP1 = 44
 player0x = 60 : player0y = 51
 player1x = 110 : player1y = 70
 drawscreen
 if switchreset then goto startgame else goto p0wins

p1wins
 COLUP0 = 44
 COLUP1 = 132
 player0x = 110 : player0y = 70
 player1x = 60 : player1y = 51
 drawscreen
 if switchreset then goto startgame else goto p1wins

tie
 COLUP0 = 68
 COLUP1 = 132
 player0x = 55 : player0y = 51
 player1x = 65 : player1y = 51
 drawscreen
 if switchreset then goto startgame else goto tie

buzz
 AUDV1 = 15
 AUDC1 = 12
 AUDF1 = 28
 z = z + 1
 if z < 100 then buzz
 AUDC1 = 0
 z = 0 
 goto player1

buzz1
 AUDV1 = 15
 AUDC1 = 12
 AUDF1 = 27
buzz1helper 
 z = z + 1
 if z <100 then buzz1helper
 AUDC1 = 0
 z = 0 
 goto paint

puttsound
 AUDV1 = 3
 AUDC1 = 7
 AUDF1 = 31
 z = z + 1
 if z < 50 then puttsound
 AUDC1 = 0
 z = 0 
 goto backtopaint

punchsound
 AUDV1 = 15
 AUDC1 = 3
 AUDF1 = 31
 z = z + 1
 if z < 100 then punchsound
 AUDC1 = 0
 z = 0 
 goto bounds

winsound0
 AUDV1 = 10
 AUDC1 = 12
 AUDF1 = 12
 frametimer = frametimer + 1
 if frametimer = 60 then sectimer = sectimer + 1
 if sectimer < 10 then winsound0
winsound1
 AUDF1 = 6
 frametimer = frametimer + 1
 if frametimer = 60 then sectimer = sectimer + 1
 if sectimer < 20 then winsound1
 AUDC1 = 0
 z = 0 
 goto finishgame